<?php

require_once(JPATH_BASE . DS . 'components' . DS . 'com_eventlist' . DS. 'helpers' . DS . 'helper.php');

class ELRepeathelper extends ELHelper {
	
 /**
    * Performs dayly scheduled cleanups
    *
    * Currently it archives and removes outdated events
    * and takes care of the recurrence of events
    *
    * @since 0.9
    */
  function cleanup()
  {
  	global $mainframe;

  	$elsettings = & ELHelper::config();
    $anticipation = $mainframe->getUserState('pluginelrepeat.params')->get('repeat_window', 30);

    $now    = time();
    $lastupdate = $elsettings->lastupdate;

    //last update later then 24h?
    //$difference = $now - $lastupdate;

    //if ( $difference > 86400 ) {

    //better: new day since last update?
    $nrdaysnow = floor($now / 86400);
    $nrdaysupdate = floor($lastupdate / 86400);

    if ( $nrdaysnow > $nrdaysupdate ) {

      $db     = & JFactory::getDBO();
      
      //first, check that the table structure has the new field. would be better if there was an install function for plugins...
      $fields = $db->getTableFields(array('#__eventlist_events'));
      if (!in_array('recurrence_first_id', array_keys($fields['#__eventlist_events']))) {
        $db->setQuery('ALTER TABLE `#__eventlist_events` ADD `recurrence_first_id` INT NOT NULL ;');
        $db->query();      	
      }

      // get the last event occurence of each recurring published events, with unlimited repeat, or last date not passed.
      $nulldate = '0000-00-00';
      $query = ' SELECT id, CASE recurrence_first_id WHEN 0 THEN id ELSE recurrence_first_id END AS first_id, '
             . ' recurrence_number, recurrence_type, recurrence_counter, '
             . ' MAX(dates) as dates, MAX(enddates) as enddates '
             . ' FROM #__eventlist_events '
             . ' WHERE recurrence_type <> "0" '
             . ' AND CASE recurrence_counter WHEN '.$nulldate.' THEN 1 ELSE NOW() < recurrence_counter END '
             . ' AND `published` = 1 '
             . ' GROUP BY first_id'
             . ' ORDER BY dates DESC';
      $db->SetQuery( $query );
      $recurrence_array = $db->loadAssocList();
            
      foreach((array) $recurrence_array as $recurrence_row) 
      {
        // get the info of reference event for the duplicates
        $ref_event = & JTable::getInstance('eventlist_events', '');
        $ref_event->load($recurrence_row['id']);
                
        // get the recurrence information
        $recurrence_number = $recurrence_row['recurrence_number'];
        $recurrence_type = $recurrence_row['recurrence_type'];
                
        // calculate next occurence date
        $recurrence_row = ELHelper::calculate_recurrence($recurrence_row);
        
        // add events as long as we are under the interval and under the limit, if specified.       
        while (($recurrence_row['recurrence_counter'] == $nulldate || strtotime($recurrence_row['dates']) <= strtotime($recurrence_row['recurrence_counter'])) 
             && strtotime($recurrence_row['dates']) <= time() + 86400*$anticipation) 
        {
          $new_event = & JTable::getInstance('eventlist_events', '');
          $new_event->bind($ref_event, array('id', 'hits', 'dates', 'enddates'));
          $new_event->recurrence_first_id = $recurrence_row['first_id'];
          $new_event->dates = $recurrence_row['dates'];
          $new_event->enddates = $recurrence_row['enddates'];
          
          if (!$new_event->store())
          {
          	JError::raise('error', 0, 'Error generating repeating events');
          }
          
          $recurrence_row = ELHelper::calculate_recurrence($recurrence_row);
        }
      }

      //delete outdated events
      if ($elsettings->oldevent == 1) {
        $query = 'DELETE FROM #__eventlist_events WHERE DATE_SUB(NOW(), INTERVAL '.$elsettings->minus.' DAY) > (IF (enddates <> '.$nulldate.', enddates, dates))';
        $db->SetQuery( $query );
        $db->Query();
      }

      //Set state archived of outdated events
      if ($elsettings->oldevent == 2) {
        $query = 'UPDATE #__eventlist_events SET published = -1 WHERE DATE_SUB(NOW(), INTERVAL '.$elsettings->minus.' DAY) > (IF (enddates <> '.$nulldate.', enddates, dates)) AND published = 1';
        $db->SetQuery( $query );
        $db->Query();
      }
      
      //Set timestamp of last cleanup
      $query = 'UPDATE #__eventlist_settings SET lastupdate = '.time().' WHERE id = 1';
      $db->SetQuery( $query );
      $db->Query();
    }
  }	
}
?>